c	***************************************************************
c	Input of numerical parameters - either from an input file
c	or directly from the terminal
c	***************************************************************
	subroutine readnum(inum,kerr)
	implicit none
	real epsn,dvgauss
	real negexp,negint,explin,softzone,deltav,vjump,conv,neglev

	integer ioerror,inum,kerr
	logical fileinp,numdef
	character*80 lfile,dummyline
	character yn

	common /accgrid/ epsn,dvgauss
	common /acclev/ conv,neglev
	common /accgauss/ negexp,negint
	common /accstep/ deltav,vjump,explin,softzone
	common /options/ fileinp,numdef
	save /accgrid/,/acclev/,/accgauss/,/accstep/,/options/

11	format(//,' *** Input of numerical parameters ***',/)
12	format(' Do you want to use built-in default values ? [y/n]: ',$)
13	format(' Do you want to use an input file ? [y/n]: ',$)
14	format(' Name of the parameter file: ',$)
15	format(' Do you want to use the same numerical parameters ',
     %  'as in the previous',/,' computation ? [y/n]: ',$)
22	format(' Cut-off for Gaussians in the line emission [sigma]: ',$)
23	format(' Cut-off for Gaussians in freq. integration [sigma]: ',$)
24	format(' Resolution in scanning the Gaussians [sigma]: ',$)
31	format(' Maximum change factor for the level densities between',
     %  ' grid points: ',$)
35	format(' Maximum velocity shift between radiative transfer',
     %  ' points [sigma]: ',$)
36	format(' Maximum velocity shift which is linearly interpolated',
     %  ' [sigma]: ',$)
37	format(' Local treatment [1=thermal,2=external radiation,',
     %  '3=Sobolev]: ',$)
38	format(' Neglection threshold for the level populations: ',$)
39	format(' Relative accuracy as convergence criterion: ',$)
c	Input formats
41	format(A1)
42	format(A80)
43	format(' ')
44	format(I4)
45	format(1PG12.5)

c	*************************************************************
c	Skip terminal interaction and take defaults for -numdefaults
c	*************************************************************
	if (numdef) goto 200
	write(6,11)
100	write(6,12)
	read (5,41) yn
	if ((yn.ne.'y').and.(yn.ne.'Y')) goto 410
c	*************************************************************
c	The default values
c	*************************************************************
200	negexp=2.5
	negint=3.2
	dvgauss=0.55
	epsn=1.2
	deltav=dvgauss
	vjump=negint
	inum=3
	neglev=1e-8
	conv=1e-4
	goto 500
c	*************************************************************
c	Use an input file
c	*************************************************************
410	if (.not.fileinp) then
	write(6,13)
	read (5,41) yn
	if ((yn.ne.'y').and.(yn.ne.'Y')) goto 310
	endif
	write(6,14)
	read (5,42) lfile
	open(14,err=120,file=lfile,status='old')
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) negexp
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) negint
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) dvgauss
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) epsn
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) deltav
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) vjump
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) inum
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) neglev
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) conv
	goto 500
c	*************************************************************
c	Use interactive input
c	*************************************************************
310	write(6,43)
	write(6,22)
	read (5,*,err=180) negexp
	write(6,23)
	read (5,*,err=180) negint
	write(6,24)
	read (5,*,err=180) dvgauss
	write(6,43)
	write(6,31)
	read (5,*,err=180) epsn
	write(6,35)
	read (5,*,err=180) deltav
	write(6,36)
	read (5,*,err=180) vjump
	write(6,43)
	write(6,37)
	read (5,*,err=180) inum
	write(6,38)
	read (5,*,err=180) neglev
	write(6,39)
	read (5,*,err=180) conv
c	*************************************************************
c	In case of interactive input store the parameters for
c	the next time in a normal input file
c	*************************************************************
72	format(/,' Do you want to store these parameters for later ',
     %  'use ? [y/n]: ',$)
	write(6,72)
	read (5,41) yn
	if ((yn.ne.'y').and.(yn.ne.'Y')) goto 500
350	write(6,14)
	read (5,42) lfile
450	open(14,err=130,file=lfile,status='new')
	write(14,22)
	write(14,43)
	write(14,45) negexp
	write(14,23)
	write(14,43)
	write(14,45) negint
	write(14,24)
	write(14,43)
	write(14,45) dvgauss
	write(14,31)
	write(14,43)
	write(14,45) epsn
	write(14,35)
	write(14,43)
	write(14,45) deltav
	write(14,36)
	write(14,43)
	write(14,45) vjump
	write(14,37)
	write(14,43)
	write(14,44) inum
	write(14,38)
	write(14,43)
	write(14,45) neglev
	write(14,39)
	write(14,43)
	write(14,45) conv
	close(14)
c	*************************************************************
c	Both cases:
c	Check the parameters for being in a reasonable range
c	Use default values if not.
c	*************************************************************
500	if (negexp.le.0.0) negexp=3.2
	if (negint.le.0.0) negint=4.2
	if (dvgauss.le.0.0) dvgauss=0.65
	if (epsn.le.1.0) epsn=1.3
	if (deltav.le.0.0) deltav=dvgauss
	if (vjump.lt.0.0) vjump=dvgauss
	if (inum.eq.0) inum=3
c	*************************************************************
c	Threshold for the transition from the linearily interpolated
c	thin approximation to the stepwise constant thick treatment
c	in radiative transfer. This is too dangerous as independent
c	parameter. An appropriate treatment is coupling to the
c	maximum density step
c	*************************************************************
	if (epsn.lt.1.03) then
	softzone=0.07
	else if (epsn.lt.1.15) then
	softzone=0.12
	else
	softzone=0.18
	endif
	explin=0.995*softzone 
	return
c	*************************************************************
c	Error handling
c	*************************************************************	
120	goto (100) ioerror(lfile,1)
	kerr=1
	return
110	goto (100) ioerror(lfile,2)
	kerr=1
	return
130	goto (450,350) ioerror(lfile,3)+1
	goto 500
58	format(/,' A numerical error occured - ',
     %  'Please correct your data input!')
180	write(6,58)
	goto 310
	end

c	***************************************************************
c	Input of all physical parameters - either from an
c	input file or directly from the terminal
c	***************************************************************
	subroutine readphys(iup,ilo,dny,fwhm,dist,deltar,ztot,kerr)
	implicit none
	integer iup,ilo,kerr
	real fwhm,dist,deltar,d0,ddd,ddv,t,dh,vt,ztot,dny
	character*80 lfile,dummyline
	character yn
	integer ioerror
	logical fileinp,numdef

	common /model/ d0,ddd,ddv,t,dh,vt
	common /options/ fileinp,numdef
	save /model/,/options/

11	format(//,' *** Input of physical parameters ***',/)
12	format(' Do you want to use an input file ? [y/n]: ',$)
13	format(' Name of the parameter file: ',$)
c	Formats for interactive parameter input
14	format(' Upper level of the transition to be observed: ',$)
15      format(' Lower level of the transition to be observed: ',$)
16	format(' Beam width [FWHP in ``]: ',$)
17	format(' Distance of the cloud [pc]: ',$)

18	format(' Kinetic gas temperature [K]: ',$)
19	format(' Relative molecular abundance [X/H2]: ',$)
20	format(' FWHM of turbulent velocity [km/s]: ',$)

21	format(' Grid spacing [pc]: ',$)
25	format(' Total depth of the cloud [pc]: ',$)
22	format(' Density zero point [cm^-3]: ',$)
23	format(' Density scaling factor [cm^-3]: ',$)
24	format(' Velocity scaling factor [km/s]: ',$)
26      format(' Frequency resolution [km/s]: ',$)

c	Input formats
41	format(A1)
42	format(A80)
43	format(' ')
44	format(I4)
45	format(1PG12.5)
	
c	First selection
	write(6,11)
100	if (.not.fileinp) then
	write(6,12)
	read (5,41) yn
	if ((yn.ne.'y').and.(yn.ne.'Y')) goto 310
	endif
c	*************************************************************
c	Use an input file
c	*************************************************************
	write(6,13)
	read (5,42) lfile
	open(14,err=120,file=lfile,status='old')
c	Global parameters
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) iup
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) ilo
	read (14,42,err=110,end=110) dummyline
        read (14,*,err=110,end=110) dny
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) fwhm
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) dist
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) t
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) dh
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) vt
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) deltar
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) ztot
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) d0
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) ddd
	read (14,42,err=110,end=110) dummyline
	read (14,*,err=110,end=110) ddv
	close(14)
	goto 500
c	*************************************************************
c	Use interactive input
c	*************************************************************
310	write(6,43)
	write(6,14)
        read (5,*,err=180) iup
        write(6,15)
        read (5,*,err=180) ilo
        write(6,26)
        read (5,*,err=180) dny
	write(6,16)
	read (5,*,err=180) fwhm
	write(6,17) 
	read (5,*,err=180) dist
	write(6,18) 
	read (5,*,err=180) t
	write(6,19) 
	read (5,*,err=180) dh
	write(6,20) 
	read (5,*,err=180) vt
	write(6,21)
	read (5,*,err=180) deltar
	write(6,25)
	read (5,*,err=180) ztot
	write(6,22)
	read (5,*,err=180) d0
	write(6,23)
	read (5,*,err=180) ddd
	write(6,24) 
	read (5,*,err=180) ddv
c	*************************************************************
c	In case of interactive input store the parameters for
c	the next time in a normal input file
c	*************************************************************
72	format(//,' Do you want to store these parameters for later ',
     %  'use ? [y/n]: ',$)
	write(6,72)
	read (5,41) yn
	if ((yn.ne.'y').and.(yn.ne.'Y')) goto 500
350	write(6,13)
	read (5,42) lfile
200	open(14,err=130,file=lfile,status='new')
	write(14,14)
	write(14,43)
	write(14,44) iup
	write(14,15)
	write(14,43)
	write(14,44) ilo
	write(14,26)
	write(14,43)
	write(14,45) dny
	write(14,16)
	write(14,43)
	write(14,45) fwhm
	write(14,17)
	write(14,43)
	write(14,45) dist
	write(14,18)
	write(14,43)
	write(14,45) t
	write(14,19)
	write(14,43)
	write(14,45) dh
	write(14,20)
	write(14,43)
	write(14,45) vt
	write(14,21)
	write(14,43)
	write(14,45) deltar
	write(14,25)
	write(14,43)
	write(14,45) ztot
	write(14,22)
	write(14,43)
	write(14,45) d0
	write(14,23)
	write(14,43)
	write(14,45) ddd
	write(14,24)
	write(14,43)
	write(14,45) ddv
	close(14)
c	*************************************************************
c	Both cases:
c	check for errors
c	*************************************************************
500	if (fwhm.le.0.0) fwhm=0.0
	return
c	*************************************************************
c	Error handling
c	*************************************************************	
120	goto (100) ioerror(lfile,1)
	kerr=1
	return
110	goto (100) ioerror(lfile,2)
	kerr=1
	return
130	goto (200,350) ioerror(lfile,3)+1
	goto 500
58	format(/,' A numerical error occured - ',
     %  'Please correct your data input!')
180	write(6,58)
	goto 310
	end

c	***********************************************************
c	Subroutine to find the corresponding line for levels
c	***********************************************************
	integer function theline(lup,ldo,lin,mesg)
	implicit none
	integer lup,ldo, lin
	character*20 mesg

	include 'fsizes.inc'
	real molmass,energy(nlev),stgew(nlev)
	integer lfrom(ntra),lto(ntra),i
	character*8 levnam(nlev)

	common /molecule/ molmass, energy, stgew, levnam
	common /lintable/ lfrom, lto
	save /molecule/, /lintable/

31	format(/,' There is no excited transition from level ',I3,
     %	  ' to level ',I3,'!',/)
32	format(/,' The transition: ',A20,' will be computed.')
c	***********************************************************
c	Check all lines
c	***********************************************************
	theline=0
	do i=1,lin
	  if ((lup.eq.lfrom(i)).and.(ldo.eq.lto(i))) theline=i
	enddo
c	Messages on the result
	if (theline.eq.0) then
	  mesg=' '
	  write(6,31) lup,ldo
	else
	  mesg=levnam(lup)//' -> '//levnam(ldo)
	  write(6,32) mesg
	endif
	return
	end

c	***********************************************************
c	Subroutine to read the input fields
c	***********************************************************
	subroutine readfield(dco,vx,vy,vz,nx,ny,nz,kerr)
	implicit none
	integer nx,ny,nz,kerr

	include 'fsizes.inc'
	real dco(ns,ns,ns),vz(ns,ns,ns)
	real vx(ns,ns,ns),vy(ns,ns,ns)
	real dx,dy,dz,z0
	character*80 lfile

13	format(' Name of the file giving the density field: ',$)
14	format(' Name of the file giving the x-velocity field: ',$)
15	format(' Name of the file giving the y-velocity field: ',$)
16	format(' Name of the file giving the z-velocity field: ',$)
c	Input formats
42	format(A80)

	write(6,13)
	read (5,42) lfile
	call cubread(dco,nx,ny,nz,dx,dy,dz,z0,lfile,kerr)
	if (kerr.ne.0) return

	write(6,14)
	read (5,42) lfile
	call cubread(vx,nx,ny,nz,dx,dy,dz,z0,lfile,kerr)
	if (kerr.ne.0) return
	write(6,15)
	read (5,42) lfile
	call cubread(vy,nx,ny,nz,dx,dy,dz,z0,lfile,kerr)
	if (kerr.ne.0) return
	write(6,16)
	read (5,42) lfile
	call cubread(vz,nx,ny,nz,dx,dy,dz,z0,lfile,kerr)
	return
	end

c	***********************************************************
c	Subroutine to write out the line profiles in a form that
c	can be read by greg or gnuplot
c	***********************************************************
	subroutine writeintens(ibeam,nx,ny,nff,off,dny,mesg)
	implicit none
	integer nff,nx,ny

	include 'fsizes.inc'
	real ibeam(ns,ns,-nf:nf),istor(ns,ns,(2*nf)+1)
	real off,dny,dx,dy,dz,z0
	integer nz,kerr,i,j,k
	character*80 lfile
	character*20 mesg
	character*140 info

13	format(/,' Name of the output file for the line profiles: ',$)
42	format(A80)

	nz=2*nff+1
	dx=off
	dy=off
	dz=dny
	z0=-dz*nff
	do 100 i=1,nx
	do 100 j=1,ny
	do 100 k=-nff,nff
	istor(i,j,k+nff+1)=ibeam(i,j,-k)
100	continue
	info= 'Line map produced by CubeLine (V.Ossenkopf 2001)'//
     %     '                      Transition: '//mesg

	write(6,13)
	read (5,42) lfile
	kerr=0
	call writecub(istor,nx,ny,nz,dx,dy,dny,z0,info,lfile,kerr)
	return
	end

c	***********************************************************
c	Set predefined constants for the output file handling and 
c	the numerical parameters via compiler option or command
c	line argument. ! This part is not standard-FORTRAN77 and 
c	may not compile everywhere ! Taking defaults, you will be 
c	asked for the options at all file output operations.
c	***********************************************************
	subroutine predefine
	integer nmax,narg,iargc,i
	logical numdef,fileinp
	character*20 string
	character*20 stnumdef(2),stfile(2)

	common /options/ fileinp,numdef
	save /options/

c	All allowed possibilities of command line parameters
	data stfile /'-fileinput','-FILEINPUT'/
	data stnumdef /'-numdefaults','-NUMDEFAULTS'/

c	***********************************************************
c	Default values (interactive mode)
c	***********************************************************
	fileinp=.false.
	numdef=.false.
c	************************************************************
c	Overwrite compile time defaults by command line parameters
c	************************************************************
	nmax=iargc()
	do 100 narg=1,nmax
	call getarg(narg,string)
	do 100 i=1,2
	if (string.eq.stfile(i)) fileinp=.true.
	if (string.eq.stnumdef(i)) numdef=.true.
100	continue
	return
	end

